<?php
/*************************
  Coppermine Photo Gallery
  ************************
  Copyright (c) 2003-2005 Coppermine Dev Team
  v1.1 originally written by Gregory DEMAR

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
**********************************************/

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

// Switch that allows overriding the bridge manager with hard-coded values
define('USE_BRIDGEMGR', 0);

require_once 'bridge/udb_base.inc.php';

class fusion_cpg_udb extends core_udb {

	function fusion_cpg_udb()
	{
		global $BRIDGE;
		
		//if (!USE_BRIDGEMGR) { // the vars that are used when bridgemgr is disabled

			// URL of your fusion
			$this->boardurl = 'http://localhost/fusion';

			// local path to your fusion config file
			require_once('../fusion/config.php');

		//}
		
		$this->multigroups = 0;
		$this->group_overrride = 1;
		$this->use_post_based_groups = 1;

		// Database connection settings
		$this->db = array(
			'name' => $db_name,
			'host' => $db_host,
			'user' => $db_user,
			'password' => $db_pass,
			'prefix' =>$db_prefix
		);
		
		// Board table names
		$this->table = array(
			'users' => 'users',
			'groups' => 'user_groups',
		);

		// Derived full table names
		$this->usertable = '`' . $this->db['name'] . '`.' . $this->db['prefix'] . $this->table['users'];
		$this->groupstable =  '`' . $this->db['name'] . '`.' . $this->db['prefix'] . $this->table['groups'];
		
		// Table field names
		$this->field = array(
			'username' => 'user_name', // name of 'username' field in users table
			'user_id' => 'user_id', // name of 'id' field in users table
			'password' => 'user_password', // name of 'password' field in users table
			'email' => 'user_email', // name of 'email' field in users table
			'regdate' => 'user_joined', // name of 'registered' field in users table
			'active' => "''", // is user account active?
			'lastvisit' => 'user_lastvisit', // name of 'location' field in users table
			'location' => 'user_location', // name of 'location' field in users table
			'website' => 'user_web', // name of 'website' field in users table
			'usertbl_group_id' => 'user_level', // name of 'group id' field in users table
			'grouptbl_group_id' => 'group_id', // name of 'group id' field in groups table
			'grouptbl_group_name' => 'group_name' // name of 'group name' field in groups table
		);
		
		// Pages to redirect to
		$this->page = array(
			'register' => '/register.php',
			'editusers' => '/members.php',
			'edituserprofile' => "/profile.php?lookup="
		);
		
		// Group ids
		$this->admingroups = array(102,103);
		$this->guestgroup = 100;
		
		// Connect to db
		$this->connect();
	}
	
	// definition of how to extract an id and password hash from a cookie
	function cookie_extraction()
	{
	    $id = 0;
		$pass = '';

        if (isset($_COOKIE['fusion_user'])){
			$cookie_vars = explode(".", $_COOKIE['fusion_user']);
			$id = is_numeric($cookie_vars['0']) ? $cookie_vars['0'] : "0";
			$pass = (preg_match("/^[0-9a-z]{32}$/", $cookie_vars['1']) ? $cookie_vars['1'] : "");
		}
		
		return ($id) ? array($id, $pass) : false;
	}
	
	function authenticate()
	{
		global $USER_DATA;

		if (!$auth = $this->cookie_extraction()) {
			$this->load_guest_data();
		} else {
			list ($id, $cookie_pass) = $auth;
			$f = $this->field;
	 
			$sql = "SELECT u.{$f['user_id']} AS id, u.{$f['username']} AS username, u.{$f['password']} AS password, u.{$f['usertbl_group_id']} AS group_id ".
					   "FROM {$this->usertable} AS u WHERE u.{$f['user_id']}='$id'";

			$result = cpg_db_query($sql, $this->link_id);
	
			if (mysql_num_rows($result)){

				$row = mysql_fetch_assoc($result);

				mysql_free_result($result);
				
				$db_pass = $this->udb_hash_db($row['password']);
				if ($db_pass === $cookie_pass) {
					$this->load_user_data($row);
				} else {
					$this->load_guest_data();
				}
			} else {
				$this->load_guest_data();
			}
		}
		
		$user_group_set = '(' . implode(',', $USER_DATA['groups']) . ')';

        $USER_DATA = array_merge($USER_DATA, $this->get_user_data($USER_DATA['groups'][0], $USER_DATA['groups'], $this->guestgroup));

		$USER_DATA['has_admin_access'] = (in_array($USER_DATA['groups'][0],$this->admingroups)) ? 1 : 0;

		$USER_DATA['can_see_all_albums'] = $USER_DATA['has_admin_access'];
		
		// avoids a template error
		if (!$USER_DATA['user_id']) $USER_DATA['can_create_albums'] = 0;
		
	    // For error checking
		$CONFIG['TABLE_USERS'] = '**ERROR**';
			
		define('USER_ID', $USER_DATA['user_id']);
        define('USER_NAME', addslashes($USER_DATA['user_name']));
        define('USER_GROUP', $USER_DATA['group_name']);
        define('USER_GROUP_SET', $user_group_set);
        define('USER_IS_ADMIN', $USER_DATA['has_admin_access']);
        define('USER_CAN_SEND_ECARDS', (int)$USER_DATA['can_send_ecards']);
        define('USER_CAN_RATE_PICTURES', (int)$USER_DATA['can_rate_pictures']);
        define('USER_CAN_POST_COMMENTS', (int)$USER_DATA['can_post_comments']);
        define('USER_CAN_UPLOAD_PICTURES', (int)$USER_DATA['can_upload_pictures']);
        define('USER_CAN_CREATE_ALBUMS', (int)$USER_DATA['can_create_albums']);
        define('USER_UPLOAD_FORM', (int)$USER_DATA['upload_form_config']);
        define('CUSTOMIZE_UPLOAD_FORM', (int)$USER_DATA['custom_user_upload']);
        define('NUM_FILE_BOXES', (int)$USER_DATA['num_file_upload']);
        define('NUM_URI_BOXES', (int)$USER_DATA['num_URI_upload']);
		
		$this->session_update();
	}

	function collect_groups()
	{

		$udb_groups = array(103 =>'Super Administrators', 102=> 'Administrators', 101=>'Members', 100=> 'Guests');

		return $udb_groups;
		
	}
	
	// definition of actions required to convert a password from user database form to cookie form
	function udb_hash_db($password)
	{
		return $password;
	}
	
	// Login
	function login_page()
	{
		$this->redirect('/login.php');
	}

	// Logout
	function logout_page()
	{
		$this->redirect('/setuser.php?logout=yes');
	}
}

// and go !
$cpg_udb = new fusion_cpg_udb;